csys.get.classifiers <- function(train, labels, algo.names = NULL, algos, ...)
{
    if(nrow(train) != length(labels)) {
        stop("The number of samples is diff. with the number of labels")
    }

    if(length(algo.names) == 0) {
        algo.names = as.vector(algos[,]$name)
    }

    cas = NULL
    for(i in 1 : length(algo.names)) {
        flag = FALSE
        name = algo.names[i]
        names = as.vector(algos$name)
        ca = NULL
        for(j in 1 : nrow(algos)) {
            if (name == names[j]) {
                algo = algos[j,]
                ## load package
                if (do.call("require",list(algo$package)) == FALSE) {
                    stop("Failed to load the required package: ", algo$package)
                }

                ## call algorithm function
                func.name = algo$func.name


                if(!as.logical(algo$data.frame) && any(!is.finite(train))) {
                    train = data.matrix(data.frame(train))
                }

                t.data = train
                t.labels = labels

                if (as.logical(algo$cbind)) {
                    t.data = cbind(labels,t.data)
                }
	        if (as.logical(algo$data.frame) && is.data.frame(t.data) == FALSE) {
                    t.data = data.frame(t.data)
                }
                if (algo$labels.formula.left != "" |
                    algo$labels.formula.right != "")
                {
                    t.labels = as.formula(paste(c(toString(algo$labels.formula.left),toString(algo$labels.formula.right)), collapse = "~"))
                }


                ## parameter list
                par.list = NULL;
                if (algo$labels.name != "") { ## use labels parameter
                    par.list = vector("list", 2);
                    names(par.list) = c(toString(algo$train.name), toString(algo$labels.name));
                }else { ## don't use labels parameter
                    par.list = vector("list", 1);
                    names(par.list) = c(toString(algo$train.name));
                }


                par.list[[toString(algo$train.name)]] = t.data

                if (algo$labels.name != "") {
                    par.list[[toString(algo$labels.name)]] = t.labels
                }

                if (as.logical(algo$pass.arguments)) {
                    par.list = c(par.list, ...)
                }

                ## debugging ...
                ##g = as.factor(t.labels)
                ##counts = as.vector(table(g))
                ##print("g:");
                ##print(g);
                ##print("counts:");
                ##print(counts);
                ##print(t.data);
                ##print(par.list);
                ##print(names(par.list));
                ## end of debugging ...

                ca = do.call(toString(func.name), par.list)
                flag = TRUE
            }
        }

        if (flag == FALSE) {
            cat(name, " is not a supported algorithm\n")
        }
        else {
            temp.list = vector("list",1);
            names(temp.list) = c(toString(name));
            temp.list[[name]] = ca;
            cas = c(cas,temp.list)
        }
    }
    if (length(algo.names) == 1) {
        return(ca);
    }##else {
    return(cas)
    ##}
}
