\name{csys.make.algorithm}
\alias{csys.make.algorithm}
\title{Add an algorithm to the supported algorithms list}
\Description{
  This function is used to add a new algorithm (format: list) to the
  given algorithms data frame. The algorithm list can be generated by
  calling csys.make.algorithm(...).

  The function returns an algorithm in the format of list.
}
\usage{
csys.make.algorithm(name,package,func.name,train.name,labels.name = "",
pass.argument = "FALSE", cbind = "FALSE", data.frame = "FALSE",
labels.formula.left = "", labels.formula.right = "")
}

\arguments{
  \item{name}{the algorithm name.}
  \item{package}{the algorithm package name which will be load when the
    algorithm function is called.}
  \item{func.name}{the algorithm function name.}
  \item{pass.argument}{indicates whether pass the rest arguments (i.e.:
    "...")to the algorithm function. Its value should be either "TRUE" or
    "FALSE". ex: if the value is TRUE, $func.name = algo_func and there
    is no other specified parameters, then algo_func(...) will be
    called.}
  \item{train.name}{the data parameter name which will be used in a call of
    algorithm function.ex: if $train.name = data and $func.name =
    algo_func, then algo_func(data = some_data) will be called.}
  \item{cbind}{whether calls cbind(label,data). Its value should be either
    "TRUE" or "FALSE".}
  \item{data.frame}{whether data is passed as a data.frame. Its value
    should be either "TRUE" or "FALSE".}
  \item{labels.name}{the label parameter name which will be used in a call of
    algorithm function.ex: if $label = formula and $func.name = algo_func, then algo_func(formula = some_labels) will be called.}
  \item{labels.formula.left}{indicates what should be the left formula part
    if the labels is passed as a formula. For example: "labels ~ .".}
  \item{labels.formula.right}{indicates what should be the right formula part
    if the labels is passed as a formula. For example: "labels ~ .".}
}

\seealso{
  \code{\link{csys.add.algorithm}, \link{csys.load.algorithm}}.
}
\keyword{csys.make.algorithm, algorithm}
