\name{csys.scale}
\alias{csys.scale}
\title{Scale the given data by a specified method.}
\Description{
  This function is responsible to scale the given data by one of supported method.
  The supported methods are:
     min-max: a linear scaling method where min -> 0, max -> 1
     mean-sd: a linear scaling method where mean -> 0, mean+sd -> 1 
     median-mad: a linear scaling method where median -> 0, median+mad -> 1
}
\usage{
csys.scale(train, test = NULL, scale.method = c("min-max", "mean-sd", "median-mad")
}

\arguments{
  \item{train}{train data used to generate classifiers.}
  \item{test}{test data which is being classified.}
  \item{scale.method}{it must be one of the supported method: min-max, mean-sd, median-mad.}
}

\seealso{
   \code{\link{csys.split}}}.
}

\keyword{csys.scale, scale}