#####
## System Test
##
## Author: Xieli Zhaofu (proj.information@gmail.com)
##   Date: 2008/12/31
#####

## initializations
prof.time <- "F:/prof.emacs";
algos.file <- "F:/algorithms.xml";
filename <- "F:/genes.txt";
data <- read.table(filename,header=FALSE);
labels <- data[1,-1];
t.labels <- t(labels);
matrix.frame <- data[-1,-1];
matrix <- as.matrix(matrix.frame);
t.matrix <- t(matrix);
algos <- csys.load.algorithm(algos.file);

## step 1
Rprof(prof.time, append = TRUE, memory.profiling = FALSE);
classifier.tree = csys.get.classifiers(t.matrix, t.labels, as.vector("my.tree"), algos);
Rprof(NULL);

Rprof(prof.time, append = TRUE, memory.profiling = FALSE);
classifier.rpart = csys.get.classifiers(t.matrix, t.labels, as.vector("rpart"), algos);
Rprof(NULL);

Rprof(prof.time, append = TRUE, memory.profiling = FALSE);
classifier.lda = csys.get.classifiers(t.matrix, t.labels, "lda", algos);
Rprof(NULL);

## the train data doesn't have dif. labels for running qda
## classifier.qda = csys.get.classifiers(t.matrix, t.labels, "qda", algos);

summary(classifier.tree);
summary(classifier.rpart);
summary(classifier.lda);

## step 2
tree.out.class = predict.tree(classifier.tree, newdata = data.frame(t.matrix), type = "class");

rpart.out.class = predict.rpart(classifier.rpart, newdata = data.frame(t.matrix), type = "class");
rpart.out.prob = predict(classifier.rpart, newdata = t.matrix, type = "prob");

lda.out = predict(classifier.lda, data.matrix(data.frame(t.matrix)));
lda.out.class = lda.out$class;
